力扣 面试题 05.06. 整数转换

思路:

牵扯到二进制数,基本上要考虑位运算符 ,相关知识可以见http://t.csdnimg.cn/fzts7

之前做过类似的题目,大致思路就是先用按位异或^找出不同位 ,再用n&(n-1)计算出不同位的个数 ,但是这道题有个小坑,就是极限了话,n刚好为int类型的最小值(即二进制数为1000......0000),此时n-1就会溢出。

就是A和B的二进制数刚好是1000......0000和0000......0000,此时n=A^B就是1000......0000,所以此时n再减1就溢出了,因此我们要考虑这个特殊情况

INT_MIN 代表int类型的最小值,即-2147483648

INT_MAX 代表int类型的最大值,即2147483647

定义INT_MIN 只能 INT_MIN = ( - INT_MAX) - 1

而不能 INT_MIN = - ( INT_MAX + 1) 因为这样就溢出最大值了

其头文件为#include<limits.h>

复制代码
int convertInteger(int A, int B)
{
    int count=0;
    int n=A^B;
    while(n)
    {
        if(n==INT_MIN)   //如果是最小值
        {
            count++;     
            break;
        }
        n=n&(n-1);       //减去一个1的个数
        count++;         
    }
    return count;
}
相关推荐
wuminyu12 小时前
JVM规范学习总结:解释器与JIT编译器如何处理JVM字节码
java·linux·c语言·jvm·c++
圣保罗的大教堂16 小时前
leetcode 453. 最小操作次数使数组元素相等 中等
leetcode
水饺编程17 小时前
第2章:Linux 基础,解压缩【.tar.bz2】压缩包文件
linux·c语言·汇编
Zwawa18 小时前
串口命令如何从字符串长成协议:帧头、长度、校验和与状态机
c语言·单片机·嵌入式
Tisfy20 小时前
LeetCode 0453.最小操作次数使数组元素相等:两次遍历(反向思维)
算法·leetcode·题解·遍历·反向思维
君万20 小时前
【LeetCode每日一题】回溯:46. 全排列 78. 子集 39. 组合总和
算法·leetcode·go
Tisfy1 天前
LeetCode 3665.统计镜子反射路径数目:三个动态规划数组
leetcode·动态规划·代理模式·题解
海绵宝宝转agent1 天前
LeetCode100 二叉树个人题解
算法·leetcode·深度优先
文丑颜不良啊1 天前
LeetCode1581~1600题目解析
java·leetcode
文丑颜不良啊1 天前
LeetCode1541~1560题目解析
java·leetcode